#include <minigui.ch>
#include <common.ch>
#include <hbclass.ch>

/******************************
*
*
* DOWNLOAD FILES FROM INTERNET
* WITHOUT USER INTERACTION
*
* MOL Marek Olszewski (2009.06.23)
* mol@pro.onet.pl
* MOL-Systemy Komputerowe Polska
* www.mol-systemy.com.pl
*
* if you are using HMG, please add in preferences additional library SOCKET
* --------------------------------------------------------------------------
*
*
*/


**********************************************

function main
load window download
activate window download
return
*-------------------------------
function TestDownload
	
	Download.DownloadedImage.Picture := "EMPTY.JPG"
	Download.DownloadedImage.Refresh
	DownloadFromWWW(	Download.T_ServerName.Value,;
						Download.T_UrlFileName.Value,;
						Download.T_LocalFileName.Value)
	Download.DownloadedImage.Picture := alltrim(Download.T_LocalFileName.Value)
	Download.DownloadedImage.Refresh
return
*-------------------------------
function TestDownloadviaProxy
	
	Download.DownloadedImage.Picture := "EMPTY.JPG"
	Download.DownloadedImage.Refresh
	DownloadFromWWWviaProxy(	Download.T_ServerName.Value,;
								Download.T_UrlFileName.Value,;
								Download.T_LocalFileName.Value,;
								Download.T_ProxyServer.Value,;
								Download.T_ProxyPort.Value, ;
								Download.T_ProxyUser.Value, ;
								Download.T_ProxyPassword.Value)

	Download.DownloadedImage.Picture := alltrim(Download.T_LocalFileName.Value)
	Download.DownloadedImage.Refresh
return
*-------------------------------

PROCEDURE DownloadFromWWW
	param cServerName, cURLFileName, cLocalFileName
	LOCAL oCon, oUrl, i
	private cUrl
	cServerName := alltrim(cServerName)
	cUrlFileName := alltrim(cUrlFileName)
	cLocalFileName := alltrim(cLocalFileName)

	delete file &cLocalFileName

	cUrl := cServerName + cUrlFileName
	
	oUrl := tURL():New( cUrl )
	IF Empty( oUrl )
		MsgBox("Invalid url " + cUrl)
		return
	ENDIF

	IF oUrl:cProto != "http"
		MsgBox('This is a header test for http. Use an http address.')
		return
	END
	
	oCon := TipClientHttp():New( oUrl )
	oCon:nConnTimeout := 20000

	WAIT WINDOW "Connecting with "+ oUrl:cServer  NOWAIT
	//MsgBox("Connecting with "+ oUrl:cServer)
	IF oCon:Open( cUrl )
		WAIT CLEAR
		MsgBox("Connection eshtablished." +chr(10)+"Press OK to retrieve" + oUrl:cPath +oUrl:cFile)
		oCon:WriteAll(cLocalFileName)
		MsgBox("Downloaded...")
		oCon:Close()
	ELSE
		WAIT CLEAR
		IF oCon:SocketCon == NIL
			cFault := "Connection not initiated"
		ELSEIF hb_InetErrorCode( oCon:SocketCon ) == 0
			cFault := "Server sayed: "+ oCon:cReply
		ELSE
			cFault := "Error in connection: " + hb_InetErrorDesc( oCon:SocketCon )
		ENDIF
		MsgBox("Can't connect with "+ oUrl:cServer + " " + cFault)
   END
 RETURN 

*------------------
FUNCTION DownloadFromWWWviaProxy
	param cServer, cURL, cLocalFileName, cProxy, nProxyPort, cProxyUser, cProxyPassword

	private oSock, cRet
	private nPort    := 80               // 8080         //

	DEFAULT nProxyPort := 8080

	cServer := substr(cServer, at("http://",cServer) +7 )
	
	oSock := THttp():New()
	
	if !empty(cProxy)
		oSock:SetProxy( cProxy, nProxyPort, cProxyUser, cProxyPassword )
	endif
	delete file &cLocalFileName
	MsgBox("Trying tonnect to " +cServer +":" +alltrim(str( nPort )) )
	if oSock:Connect( cServer, nPort )
		MsgBox("Connected. Trying to download file")
		cAnswer := oSock:Get( cServer+cUrl)

		// remove HTTP header
		nPos := at(chr(13)+chr(10)+chr(13)+chr(10), cAnswer)
		cHeader := left(cAnswer, nPos+4)
		// we must cut off HTTP header
		cAnswer := substr(cAnswer,nPos+4)

		// search for file length
		nPos := at("Content-Length:",cHeader)
		if nPos > 0
			nLengthOfFile := val(substr(cHeader,nPos+len("Content-Length:")))
		else
			// something wrong
			nLengthOfFile := 0
		endif
		if nLengthOfFile <> len(cAnswer)
			// something was wrong
			MsgBox("something was wrong " + cHeader)
		else
			nFile := FCreate(cLocalFileName,0)
			FWrite(nFile, cAnswer)
			FClose(nFile)
		endif



		// Trying to close connection
		if oSock:Close()
			MsgBox("Close connection successfull")
		else
			MsgBox("Error on close connection")
		endif
    else
		MsgBox("Connection refused")
	endif

 RETURN NIL
